<?php
namespace Teknisa\EST\Modules\Relatorios\Services;

use Teknisa\Libs\Util\DateUtil;

class Est70000ResumoDeOperacoesService {

    protected $factory;

	public function __construct($factory) {
		$this->factory = $factory;
	}
	
	// This function gets groupFili to verifies if it owns main group or groups by unity
	public function getGroupFiliInfo ($CDGRUPPROD){
		$params = ['CDGRUPPROD' => $CDGRUPPROD ];
		return $this->factory->getGroupFiliInfo($params);
	}
	
    // This function Manages final dataSet
	public function dataSetBuilder($columns,$sales){
        $rowsMetadata = [
            "VLRLIQUIDO" => "Venda Líquida",
            "VLRBRUTO" => "Venda Bruta",
            "VRDEVOLUCAO" => "Devolução de Compra"
        ];
        
        foreach($rowsMetadata as $field => $title){
            $dataSet[] = $this->rowBuilder($columns,$sales,$field,$title);
        }
        return $dataSet;
    }
    
    //This function builds a each row
    public function rowBuilder($columns,$sales,$field,$title){
        $total = 0;
        foreach($sales as $sale){
            foreach($sale as $key => $value){
                foreach($columns as $column){
                    if($key === $field && $sale['CDSUBGRPROD'] == $column['CDSUBGRPROD']){
                        if(!isset($row["TITLE"]))
                            $row[] = ["TITLE" => $title];
                        $row[] = [ $column['CDSUBGRPROD'] => $sale[$key]]; 
                        $total += $sale[$key] ?? 0;
                    }
                }
            }
        }
        
        $row[] = ['TOTAL' => $total];
        // This function works like flat function in Js 
        return call_user_func_array('array_merge', $row);
    }
}